
clear 
delete result.dat
diary result.dat
diary on

n      = input('Mesh number = ');

tic;
%
% Generate the matrix A in the project_2009
%
mtx_A1      = 4*eye(n);
mtx_A1(2,1) = -1;
for ii=2:n-1
    mtx_A1(ii-1,ii) = -1;
    mtx_A1(ii+1,ii) = -1;
end
mtx_A1(n-1,n)    = -1;

tmp              = [ -eye(n); mtx_A1; -eye(n) ];
mtx_A            = zeros(n*n);
mtx_A(1:2*n,1:n) = [ mtx_A1; -eye(n) ];
for ii = 2:n-1
    mtx_A((ii-2)*n+1:(ii+1)*n,(ii-1)*n+1:ii*n) = tmp;
end
mtx_A((n-2)*n+1:n*n,(n-1)*n+1:n*n) = [ -eye(n); mtx_A1 ];
fprintf('CPU time for generating coefficient matrix is %11.4e \n',toc);

%
% Construct grid ponits
%
leng_h = 1 / ( n + 1 );
x      = leng_h:leng_h:n*leng_h;
y      = x;

%
% Generate the right hand side vector in the project_2009
%
rhs_f  = zeros(n^2,1);
for jj = 1:n
%     for ii = 1:n
%         rhs_f1((jj-1)*n+ii) = 2 * pi^2 * sin(pi * x(ii)) * sin(pi * y(jj));
%     end
    rhs_f((jj-1)*n+1:jj*n,1) = 2 * leng_h^2 * pi^2 * sin(pi * x) * sin(pi * y(jj));
end

tic;
sol = mtx_A \ rhs_f;
fprintf('CPU time for solving dense linear system is %11.4e \n',toc);

[xx, yy] = meshgrid(x, y);

figure(1)
mesh(xx', yy', reshape(sol,n,n));
xlabel('x');
ylabel('y');
zlabel('u');

figure(2)
surf(xx', yy', reshape(sol,n,n));
shading interp;
xlabel('x');
ylabel('y');
zlabel('u');

diary off
