
clear 
delete result.dat
diary result.dat
diary on

n      = input('Mesh number = ');

tic;
%
% Generate the matrix A with sparse format
%
i_idx = zeros(3*n-2,1);
j_idx = zeros(3*n-2,1);
val   = zeros(3*n-2,1);

i_idx(1:n,1) = 1:n;
j_idx(1:n,1) = 1:n;
val(1:n,1)   = 4 * ones(n,1);

i_idx(n+1:2*n-1,1) = 1:n-1;
j_idx(n+1:2*n-1,1) = 2:n;
val(n+1:2*n-1,1)   = -ones(n-1,1);

i_idx(2*n:3*n-2,1) = 2:n;
j_idx(2*n:3*n-2,1) = 1:n-1;
val(2*n:3*n-2,1)   = -ones(n-1,1);

m        = ( 3 * n - 2 ) * n + 2 * ( n - 1 ) * n;
m2       = 3 * n - 2;
i_idx_A  = zeros(m,1);
j_idx_A  = zeros(m,1);
val_A    = zeros(m,1);

for ii = 1:n
    i_idx_A((ii-1)*m2+1:ii*m2,1) = i_idx + ( ii - 1 ) * n;
    j_idx_A((ii-1)*m2+1:ii*m2,1) = j_idx + ( ii - 1 ) * n;
    val_A((ii-1)*m2+1:ii*m2,1)   = val;
end

i_idx_A(m2*n+1:m2*n+(n-1)*n,1) = 1:(n-1)*n;
j_idx_A(m2*n+1:m2*n+(n-1)*n,1) = n+1:n*n;
val_A(m2*n+1:m2*n+(n-1)*n,1)   = -ones((n-1)*n,1);
i_idx_A(m2*n+(n-1)*n+1:m,1)    = n+1:n*n;
j_idx_A(m2*n+(n-1)*n+1:m,1)    = 1:(n-1)*n;
val_A(m2*n+(n-1)*n+1:m,1)      = -ones((n-1)*n,1);

mtx_A = sparse(i_idx_A, j_idx_A, val_A);

fprintf('CPU time for generating large sparse coefficient matrix is %11.4e \n',toc);

%
% Construct grid ponits
%
leng_h = 1 / ( n + 1 );
x      = leng_h:leng_h:n*leng_h;
y      = x;

%
% Generate the right hand side vector in the project_2009
%
rhs_f  = zeros(n^2,1);
for jj = 1:n
%     for ii = 1:n
%         rhs_f1((jj-1)*n+ii) = 2 * pi^2 * sin(pi * x(ii)) * sin(pi * y(jj));
%     end
    rhs_f((jj-1)*n+1:jj*n,1) = 2 * leng_h^2 * pi^2 * sin(pi * x) * sin(pi * y(jj));
end

tic;
sol = mtx_A \ rhs_f;
fprintf('CPU time for solving large sparse linear system is %11.4e \n',toc);

[xx, yy] = meshgrid(x, y);

figure(1)
mesh(xx', yy', reshape(sol,n,n));
xlabel('x');
ylabel('y');
zlabel('u');

figure(2)
surf(xx', yy', reshape(sol,n,n));
shading interp;
xlabel('x');
ylabel('y');
zlabel('u');

diary off
