%
% Solve a solution of the nonlinear equation
%        pi+(1/2)*sin(x/2)-x = 0,  x in (0, 2*pi)
% by the newton's method
%

tol   = 1.0e-15;
x_old = input('please input an initial value between 0 and 2*pi ==> ');

x0    = x_old;
maxit = 1000 ;
k     = 1;
x     = x0 - (pi+(1/2)*sin(x0/2)-x0) / ((1/4) * cos(x0/2) - 1) ;

fprintf(' k            x(k)              |x(k)-x(k-1)|     f(x(k)) \n');
fprintf('-------------------------------------------------------------\n');
fprintf('%2.0f  %24.16e  %14.4e  %14.4e \n',k, x, abs(x-x0), ...
    pi+(1/2)*sin(x/2)-x);

while k <= maxit && abs(x-x0)/abs(x) >= tol ;
    k  = k+1 ;
    x0 = x ;
    x  = x0 - (pi+(1/2)*sin(x0/2)-x0) / ((1/4) * cos(x0/2) - 1) ;
    fprintf('%2.0f  %24.16e  %14.4e  %14.4e \n',k, x, abs(x-x0), ...
            pi+(1/2)*sin(x/2)-x);
end

fprintf('-------------------------------------------------------------\n');
if ( k > maxit )
    fprintf('Newton method diverges for initial point %24.16e \n', x_old);
end
